unit UClient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, XML, StdCtrls, ComCtrls, DateUtils, ExtCtrls;

type
  TClientFrm = class(TForm)
    http: TIdHTTP;
    cbStart: TComboBox;
    Label1: TLabel;
    cbKonec: TComboBox;
    Label2: TLabel;
    cbPres: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    txtPocet: TEdit;
    udPocet: TUpDown;
    Label5: TLabel;
    txtOdjezd: TEdit;
    Label6: TLabel;
    txtPrestupy: TEdit;
    udPrestupy: TUpDown;
    btnVyhledat: TButton;
    Bevel1: TBevel;
    Label7: TLabel;
    lblPocet: TLabel;
    Label8: TLabel;
    lblAct: TLabel;
    Button1: TButton;
    Button2: TButton;
    Spojeni: TRichEdit;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnVyhledatClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure ParsujStanice;
    function ZiskejCas: string; // f-ce na zskn aktulnho asu hH:MM
    function HTTPString(S: string): string;
    procedure ParsujSpojeni;
    function AtributExistuje(Node: IXMLDOMNode; atribut: string): boolean; 
  public
    { Public declarations }
  end;

var
  ClientFrm: TClientFrm; // samotn formul, na kterm pracujeme
  SeznamStanic: TStringList; // StringList se seznamem stanic

  ActSpojeni: integer; // promnn pro aktuln slo nalezenho spoje
  PocetSpojeni: integer; // celkem nalezeno spoj
  Spoj: Array of WideString; // jednotliv spoje v textovm formtu

implementation

{$R *.dfm}

uses
  UClientConnect; // pouvme jednotku s formulem "Pipojit se"

procedure TClientFrm.FormShow(Sender: TObject);
var
  soubor: TStringList;
begin
  ClientHeight := 163;
  soubor := TStringList.Create;
  ConnectFrm.ShowModal; // zobrazme formul pro pipojen
  if http.Tag = 0 then begin
    try  // nastane-li chyba pi zskvn dat, upozornme uivatele
      soubor.text := http.Get('/SeznamStanic'); // zskme seznam stanic ve formtu XML
    except
      MessageBox(Handle, 'Chyba pi zskvn seznamu stanic!', 'Chyba', MB_ICONERROR);
      application.terminate; // skonme aplikaci
      exit;
    end;
    soubor.SaveToFile(ExtractFilePath(Application.ExeName)+'temp.xml'); // ulome soubor do doasnho adrese
    soubor.Free;
    ParsujStanice;
    // nyn, kdy mme seznam stanic naten, meme smazat doasn soubor
    if FileExists(ExtractFilePath(Application.ExeName)+'temp.xml') then
      DeleteFile(ExtractFilePath(Application.ExeName)+'temp.xml');
  end;
end;

procedure TClientFrm.ParsujStanice;
var
  soubor: IXMLDOMDocument;
  seznam, stanice: IXMLDOMNodeList;
  i, j: integer;
begin
  soubor := CoDOMDocument.Create;
  try  // oetme chybou v ppad, e soubor nepjde pest
    soubor.load(ExtractFilePath(Application.Exename)+'temp.xml');
  except
    MessageBox(Handle, 'Soubor temp.xml nelze nast!', 'Chyba', MB_ICONERROR);
    application.terminate; // ukonme aplikaci po chyb
  end;
  // vybereme vechny stanice ze SeznamuStanic
  seznam := soubor.selectNodes('//SeznamStanic');
  for i := 0 to seznam.length-1 do begin
    stanice := seznam.item[i].selectNodes('//Stanice');
    for j := 0 to stanice.length-1 do
      SeznamStanic.Add(stanice.item[j].text);
  end;
  // hur, mme nateny stanice
  SeznamStanic.Sort;
  // jet seznam stanic pro jistotu seadme (dle abecedy)
  // a nyn vlome seznamy stanic do ComboBox pro uivatele
  Randomize;  // nejdv samozejm "zamchme" sla
  cbStart.Items.AddStrings(SeznamStanic);
  cbStart.ItemIndex := Random(SeznamStanic.Count); // a vybereme nhodnou poloku v seznamu
  cbKonec.Items.AddStrings(SeznamStanic);
  cbKonec.ItemIndex := Random(SeznamStanic.Count); // opt vybereme nhodnou poloku v seznamu
  cbPres.Items.AddStrings(SeznamStanic);

  txtOdjezd.Text := ZiskejCas; // a as odjezdu nastavme na aktuln as
end;

procedure TClientFrm.FormCreate(Sender: TObject);
begin
  SeznamStanic := TStringList.Create;
  // inicializujeme promnnou SeznamStanic jako TStringList
  // (do tto promnn pozdji ulome zskan seznam stanic)
end;

function TClientFrm.ZiskejCas: string;
var
  hodiny, minuty: integer;
begin
  hodiny := HourOf(Time); // zjistme aktuln hodinu
  minuty := MinuteOf(Time); // zjistme aktuln minutu
  result := inttostr(hodiny); // do vsledku opeme hodinu
  if minuty < 10 then // pokud je minut mn ne 10,
    result := result + ':0' + inttostr(minuty) // pidme nejdve nulu
  else
    result := result + ':' + inttostr(minuty);
end;

procedure TClientFrm.btnVyhledatClick(Sender: TObject);
var
  soubor: TStringList;
  PresString: string;
begin
  ClientHeight := 513; // zvtme formul (aby mohl uivatel vidt nalezen spojen)
  if cbPres.ItemIndex = 0 then
    PresString := ''
  else
    PresString := '&pres='+cbpres.Text;
  soubor := TStringList.Create;
  try  // nastane-li chyba pi zskvn dat, upozornme uivatele
    soubor.text := http.Get('/NajdiSpojeni?odkud='+HTTPString(cbStart.text)+'&kam='+HTTPString(cbKonec.text)+PresString+'&odjezd='+StringReplace(txtOdjezd.Text,':','',[rfReplaceAll])+'&prestupy='+txtPrestupy.text+'&spojeni='+txtPocet.Text);
  except
    MessageBox(Handle, 'Chyba pi zskvn spojen!', 'Chyba', MB_ICONERROR);
    application.terminate;  // vypneme aplikaci
    exit;
  end;
  soubor.SaveToFile(ExtractFilePath(Application.ExeName)+'temp.xml');
  soubor.Free; // uvolnme soubor z pamti
  // nyn, kdy mme spojen natena, meme smazat doasn soubor
  ParsujSpojeni;
  if FileExists(ExtractFilePath(Application.ExeName)+'temp.xml') then
    DeleteFile(ExtractFilePath(Application.ExeName)+'temp.xml');
end;

function TClientFrm.HTTPString(S: string): string;
begin
  result := StringReplace(S, ' ', '+', [rfReplaceAll]);
end;

procedure TClientFrm.ParsujSpojeni;
var
  soubor: IXMLDOMDocument;
  seznam, spoje, linky, stanice: IXMLDOMNodeList;
  i, j, k, l: integer;
  prvniStanice: boolean;
  SL: TStringList;
begin
  SL := TStringList.Create;
  lblPocet.Caption := '<vykejte, prosm>';
  lblAct.Caption := '(dn spojen)';
  Button1.Enabled := False;
  Button2.Enabled := False;
  soubor := CoDOMDocument.Create;
  try  // oetme chybou v ppad, e soubor nepjde pest
    soubor.load(ExtractFilePath(Application.Exename)+'temp.xml');
  except
    MessageBox(Handle, 'Soubor temp.xml nelze nast!', 'Chyba', MB_ICONERROR);
    application.terminate; // ukonme aplikaci po chyb
    exit; // ukonme tedy proceduru zpracovn
  end;

  // vybereme Ndy :-) s nzvem Chyba
  // pokud jejich poet bude > 0, znamen to, e server vrtil
  // chybovou hlku. my ji zobrazme MessageBoxem (WinAPI)
  seznam := soubor.selectNodes('//Chyba');
  if seznam.length > 0 then begin
    MessageBox(Handle, PChar(seznam.item[0].text), 'Chyba ze serveru', MB_ICONERROR);
    exit;
  end;

  // vybereme vechna spojen z <Spojeni>
  seznam := soubor.selectNodes('//Spojeni');
  for i := 0 to seznam.length-1 do begin
    spoje := seznam.item[i].childNodes;
    pocetSpojeni := spoje.length;
    SetLength(Spoj, pocetSpojeni);
    for j := 0 to spoje.length-1 do begin
      SL.Clear;
      SL.Add('pClient - vyhledvn jzdnch d');
      SL.add('       vsledek vyhledvn');
      SL.add('===================================');
      Sl.Add('');
      SL.Add('  Nalezen spoj slo '+inttostr(j+1)+' z '+inttostr(spoje.length));
      SL.Add('');
      linky := spoje.item[j].childNodes;
      SL.Add('  Poet pestup u tohoto spoje: '+inttostr(linky.length-1));
      SL.Add('');
      for k := 0 to linky.length-1 do begin
        if linky.item[k].parentNode.specified <> spoje[j].specified then break;
        SL.Add('    Oznaen vlaku: '+linky.item[k].attributes.getNamedItem('cislo').text);
        stanice := linky.item[k].childNodes;
        prvniStanice := true;
        for l := 0 to stanice.length-1 do begin
          // zde musme zjiovat, zda Nda :-) obsahuje atributy odjezd a prijezd,
          // podle toho pak vypeme dek s odjezdem/pjezdem vlaku a stanic
          if atributExistuje(stanice.item[l],'odjezd') and (not atributExistuje(stanice.item[l],'prijezd')) then
            SL.Add('        ->         '+stanice.item[l].attributes.getNamedItem('odjezd').text+'   '+stanice.item[l].text)
          else if atributExistuje(stanice.item[l],'prijezd') and (not atributExistuje(stanice.item[l],'odjezd')) then
            SL.Add('        ->  '+stanice.item[l].attributes.getNamedItem('prijezd').text+'          '+stanice.item[l].text)
          else if atributExistuje(stanice.item[l],'prijezd') and atributExistuje(stanice.item[l],'odjezd') then
            SL.Add('        ->  '+stanice.item[l].attributes.getNamedItem('prijezd').text+'  '+stanice.item[l].attributes.getNamedItem('odjezd').text+'   '+stanice.item[l].text)
          // pokud ale zjistme, e v tto Nd :-) se jedn o poznmku,
          // vypeme jen poznmku (docela logick :-)
          else if stanice.item[l].nodeName = 'Poznamka' then begin
            if prvniStanice then begin
              SL.Add(''); // ped prvn poznmkou bude nov dek
              prvniStanice := false; // ozname, e Poznmky ji zaaly
            end;
            SL.Add('      * Poznmka: '+stanice.item[l].text);
          end;
        end;
        SL.Add('');
      end;
      Spoj[j] := SL.text;
    end;
    lblPocet.Caption := inttostr(spoje.length);
    if spoje.length > 0 then begin
      ActSpojeni := 0; // ozna 1. nalezen spojen za aktuln
      Spojeni.Text := Spoj[0]; // vype prvn nalezen spojen do RichBoxu
      lblAct.Caption := '1.'; // vypeme, e aktuln spoj m slo 1.
      if spoje.length > 1 then // pokud jsme nalezli vce ne 1 spojen,
        Button2.Enabled := True; // uvolnme tlatko pro pepnut na dal spoj
    end;
  end;
  // hur, mme natena spojen
end;

procedure TClientFrm.Button2Click(Sender: TObject);
begin
  inc(ActSpojeni);
  Spojeni.Text := Spoj[ActSpojeni];
  Button1.Enabled := true;
  if ActSpojeni = (PocetSpojeni-1) then
    Button2.Enabled := false; // nepovolme dal posunut spoje,
                              // pokud ji neexistuje
  lblAct.Caption := inttostr(actSpojeni+1)+'.';
end;

procedure TClientFrm.Button1Click(Sender: TObject);
begin
  dec(ActSpojeni);
  Spojeni.Text := Spoj[ActSpojeni];
  Button2.Enabled := true;
  if ActSpojeni = 0 then
    Button1.Enabled := false; // nepovolme dal zptn posunut spoje,
                              // pokud je aktuln index roven nule
  lblAct.Caption := inttostr(actSpojeni+1)+'.';
end;

function TClientFrm.AtributExistuje(Node: IXMLDOMNode; Atribut: string): boolean;
var
  i: integer;
begin
  // tato f-ce zjiuje, zda seznam atribut v dan Nod :-) obsahuje
  // poloku (atribut) zadanou jako parametr Atribut
  result := false;
  for i := 0 to Node.attributes.length-1 do begin
    if Node.attributes[i].nodeName = atribut then begin // atribut nalezen
      result := true;
      break;
    end;
  end;
end;

end.
